<template>
    <div>
        <div class="progress" v-show="loading && loading == 'determinate'">
            <div class="determinate" :style="'width: '+progress+'%'"></div>
        </div>
        <div class="progress" v-show="loading && loading == 'indeterminate'">
            <div class="indeterminate"></div>
        </div>
        <div v-show="loading && loading == 'spinner'" class="overlay-spinner">
            <div class="text-info">{{ text }}</div>
            <div class="preloader-wrapper big active">
                <div class="spinner-layer spinner-blue">
                    <div class="circle-clipper left">
                        <div class="circle"></div>
                    </div><div class="gap-patch">
                    <div class="circle"></div>
                </div><div class="circle-clipper right">
                    <div class="circle"></div>
                </div>
                </div>

                <div class="spinner-layer spinner-red">
                    <div class="circle-clipper left">
                        <div class="circle"></div>
                    </div><div class="gap-patch">
                    <div class="circle"></div>
                </div><div class="circle-clipper right">
                    <div class="circle"></div>
                </div>
                </div>

                <div class="spinner-layer spinner-yellow">
                    <div class="circle-clipper left">
                        <div class="circle"></div>
                    </div><div class="gap-patch">
                    <div class="circle"></div>
                </div><div class="circle-clipper right">
                    <div class="circle"></div>
                </div>
                </div>

                <div class="spinner-layer spinner-green">
                    <div class="circle-clipper left">
                        <div class="circle"></div>
                    </div><div class="gap-patch">
                    <div class="circle"></div>
                </div><div class="circle-clipper right">
                    <div class="circle"></div>
                </div>
                </div>
            </div>
            <div class="spinner-overlay" style="z-index: 1002; display: block; opacity: 0.5;"></div>

        </div>
    </div>
</template>
<script>
    export default {
        data() {
            return {
                loading: false,
                progress: 0,
                text:''
            }
        },
        methods: {
            show(args) {
                console.log(args.type)
                this.loading = args.type
                this.text = args.text
            },
            hide() {
                this.loading = false
            }
        },
        mounted() {
            Event.listen('loading-show', this.show)
            Event.listen('loading-hide', this.hide)
            Event.listen('loading-progress', value => this.progress = value)
        }
    }

</script>

<style scoped>
    .spinner-overlay {
        background: #000;
        width: 100vw;
        height: 100vh;
        position: fixed;
        top: 0;
        left: 0;
        z-index: 99;
    }
    .overlay-spinner {
        align-items: center;
        position: fixed;
        width: 100vw;
        height: 100vh;
        top: 0;
        left: 0;
        display: -webkit-box;
        display: -ms-flexbox;
        display: flex;
        -webkit-box-align: center;
        -ms-flex-align: center;
        -webkit-box-pack: center;
        -ms-flex-pack: center;
        justify-content: center;
        z-index: 10;
    }
    .preloader-wrapper.big.active {
        z-index: 9999;
    }
    .text-info {
        position: fixed;
        color: #fff;
        z-index: 999999;
    }
</style>